"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function ReadOnly() {
    return function (target, key) {
        var getSet = {
            get: function () {
                return this["_" + key];
            },
            set: function (newVal) {
                var setter = target.__lookupSetter__(key);
                setter = !setter || setter === getSet.set ? (function (v) { return v; }) : setter;
                this["_" + key] = this["_" + key] === undefined ?
                    setter.call(this, newVal) : this["_" + key];
            },
            enumerable: true,
            configurable: true
        };
        Object.defineProperty(target, key, getSet);
    };
}
exports.ReadOnly = ReadOnly;
//# sourceMappingURL=read-only.decorator.js.map