"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var g = require("window-or-global");
require("reflect-metadata");
exports.requiredMetadataKey = g.ConvectorRequiredMetadataKey || Symbol('required');
g.ConvectorRequiredMetadataKey = exports.requiredMetadataKey;
function Required() {
    return function (target, key) {
        var required = Reflect.getMetadata(exports.requiredMetadataKey, target);
        Reflect.defineMetadata(exports.requiredMetadataKey, tslib_1.__assign({}, required, (_a = {}, _a[key] = true, _a)), target);
        var _a;
    };
}
exports.Required = Required;
function ensureRequired(obj) {
    var required = {};
    try {
        required = Reflect.getMetadata(exports.requiredMetadataKey, obj) || {};
    }
    catch (e) {
    }
    return Object.keys(required)
        .every(function (k) {
        var res = !required[k] || obj[k] !== undefined;
        if (!res) {
            console.log("Validation error. Field " + k + " is required but was not found.");
        }
        return res;
    });
}
exports.ensureRequired = ensureRequired;
//# sourceMappingURL=required.decorator.js.map