"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var g = require("window-or-global");
require("reflect-metadata");
exports.validateMetadataKey = g.ConvectorValidateMetadataKey || Symbol('validate');
g.ConvectorValidateMetadataKey = exports.validateMetadataKey;
function Validate(input) {
    var schema = input;
    if ('schema' in input) {
        schema = input.schema();
    }
    return function (target, key) {
        var getSet = {
            get: function () {
                return this["_" + key];
            },
            set: function (newVal) {
                var setter = target.__lookupSetter__(key);
                setter = !setter || setter === getSet.set ? (function (v) { return v; }) : setter;
                try {
                    this["_" + key] = schema.validateSync(setter.call(this, newVal));
                }
                catch (ex) {
                    ex.message = "Error for field '" + key + "' with val '" + JSON.stringify(newVal) + "' " + ex.message;
                    throw ex;
                }
            },
            enumerable: true,
            configurable: true
        };
        Object.defineProperty(target, key, getSet);
        var validated = Reflect.getMetadata(exports.validateMetadataKey, target);
        Reflect.defineMetadata(exports.validateMetadataKey, tslib_1.__assign({}, validated, (_a = {}, _a[key] = schema, _a)), target);
        var _a;
    };
}
exports.Validate = Validate;
function getPropertiesValidation(obj) {
    var validated = {};
    try {
        validated = Reflect.getMetadata(exports.validateMetadataKey, obj) || {};
    }
    catch (e) {
    }
    return validated;
}
exports.getPropertiesValidation = getPropertiesValidation;
function getValidatedProperties(obj) {
    return Object.keys(getPropertiesValidation(obj));
}
exports.getValidatedProperties = getValidatedProperties;
//# sourceMappingURL=validate.decorator.js.map